# TODO:
# - actually build kernel module
# - fix and package xpmem.rules (wrong dir, MODE=0666 looks evil)
#
# Conditional build:
%bcond_without	static_libs	# static library
%bcond_without	userspace	# user space library
%bcond_with	kernel		# kernel module
#
Summary:	XPMEM library
Summary(pl.UTF-8):	Bibliotek XPMEM
Name:		xpmem
# project version is 0.2 (configure.ac /AC_INIT, xpmem-lib.spec), kernel module versioned as 2.6.5 (xpmem-kmod.spec)
Version:	0.2
%define	gitref	3bcab55479489fdd93847fa04c58ab16e9c0b3fd
%define	snap	20240912
%define	rel	1
Release:	0.%{snap}.1
License:	LGPL v2.1 (library), GPL v2 (kernel module)
Group:		Libraries
Source0:	https://github.com/hpc/xpmem/archive/%{gitref}/%{name}-%{snap}.tar.gz
# Source0-md5:	f4292bba7b436646f831ea3d254f29b9
Patch0:		%{name}-pc.patch
URL:		https://github.com/hpc/xpmem
BuildRequires:	autoconf >= 2.50
BuildRequires:	automake >= 1:1.1
BuildRequires:	libtool
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%description
XPMEM is a Linux kernel module that enables a process to map the
memory of another process into its virtual address space.

This is an experimental version of XPMEM based on a version provided
by Cray and uploaded orignally to <https://code.google.com/p/xpmem>.
This version supports any Linux kernel 3.12 and newer (tested up to
5.8.x). Keep in mind there may be bugs and this version may cause
kernel panics, code crashes, eat your cat, etc.

%description -l pl.UTF-8
XPMEM to moduł jądra Linuksa pozwalający procesowi odwzorować
pamięć innego procesu wewnątrz własnej wirtualnej przestrzeni
adresowej.

To jest eksperymentalna wersja XPMEM oparta na wersji udostępnionej
przez firmę Cray, pierwotnie w repozytorium
<https://code.google.com/p/xpmem>. Obsługuje jądra Linuksa od wersji
3.12 (testowane do 5.8.x). Uwaga, mogą być błędy, a ta wersja może
powodować paniki jądra i awarie kodu, zjeść kota itp.

%package devel
Summary:	Header files for XPMEM library
Summary(pl.UTF-8):	Pliki nagłówkowe biblioteki XPMEM
Group:		Development/Libraries
Requires:	%{name} = %{version}-%{release}

%description devel
Header files for XPMEM library.

%description devel -l pl.UTF-8
Pliki nagłówkowe biblioteki XPMEM.

%package static
Summary:	Static XPMEM library
Summary(pl.UTF-8):	Statyczna biblioteka XPMEM
Group:		Development/Libraries
Requires:	%{name}-devel = %{version}-%{release}

%description static
Static XPMEM library.

%description static -l pl.UTF-8
Statyczna biblioteka XPMEM.

%prep
%setup -q -n %{name}-%{gitref}
%patch -P0 -p1

%build
%{__libtoolize}
%{__aclocal} -I m4
%{__autoconf}
%{__autoheader}
%{__automake}
%configure \
	--disable-kernel-module \
	--disable-silent-rules \
	%{!?with_static_libs:--disable-static}

%if %{with userspace}
%{__make}
%endif

%install
rm -rf $RPM_BUILD_ROOT

%if %{with userspace}
%{__make} install \
	DESTDIR=$RPM_BUILD_ROOT

# no external dependencies, obsoleted by pkg-config
%{__rm} $RPM_BUILD_ROOT%{_libdir}/libxpmem.la
%endif

%clean
rm -rf $RPM_BUILD_ROOT

%post	-p /sbin/ldconfig
%postun	-p /sbin/ldconfig

%if %{with userspace}
%files
%defattr(644,root,root,755)
%doc AUTHORS ChangeLog README
%attr(755,root,root) %{_libdir}/libxpmem.so.*.*.*
%ghost %{_libdir}/libxpmem.so.0

%files devel
%defattr(644,root,root,755)
%{_libdir}/libxpmem.so
%{_includedir}/xpmem.h
%{_pkgconfigdir}/cray-xpmem.pc

%if %{with static_libs}
%files static
%defattr(644,root,root,755)
%{_libdir}/libxpmem.a
%endif
%endif
%changelog
* Fri Jun 13 2025 PLD Linux Team <feedback@pld-linux.org>
- For complete changelog see: http://git.pld-linux.org/?p=packages/xpmem.git;a=log;h=master

* Fri Jun 13 2025 Jakub Bogusz <qboosh@pld-linux.org> b1d05ae
- new

